/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER             "0.1"
#define BUFFSZ          4096
#define NICKOFF         0x1a64
#define PWDOFF          0x1ae4



#ifndef u_char
    #define u_char  unsigned char
#endif



void t98_pwd(u_char *pwd);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE    *fd;
    u_char  buff[BUFFSZ + 1];


    setbuf(stdout, NULL);

    fputs("\n"
        "Eric's Telnet 98 password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <.config>\n"
            "\n"
            "The file is located in the folder Userdata\\user\n"
            "\n", argv[0]);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    printf("\nOpening file %s\n\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    if(fseek(fd, NICKOFF, SEEK_SET) < 0) std_err();
    fgets(buff, BUFFSZ, fd);
    printf("Nickname:   %s\n", buff);

    if(fseek(fd, PWDOFF, SEEK_SET) < 0) std_err();
    fgets(buff, BUFFSZ, fd);
    t98_pwd(buff);
    printf("Password:   %s\n", buff);

    fclose(fd);

    fputs("\n\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void t98_pwd(u_char *pwd) {
    while(*pwd) {
        *pwd++ ^= 0xff;
    }
}



void std_err(void) {
    perror("\nError");
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


